Index: issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp	(revision 26744)
@@ -2933,16 +3153,20 @@
 	IssmDouble* surface   = xNew<IssmDouble>(numvertices);
 
-	element->FindParam(&dim,DomainDimensionEnum);
 	element->FindParam(&domaintype,DomainTypeEnum);
 	rho_ice =element->FindParam(MaterialsRhoIceEnum);
 	g       =element->FindParam(ConstantsGEnum);
-	if(dim==2){
-		element->GetInputListOnVertices(thickness,ThicknessEnum);
-		for(i=0;i<numvertices;i++) pressure[i]=rho_ice*g*thickness[i];
-	}
-	else{
-		element->GetVerticesCoordinates(&xyz_list);
-		element->GetInputListOnVertices(surface,SurfaceEnum);
-		for(i=0;i<numvertices;i++) pressure[i]=rho_ice*g*(surface[i]-xyz_list[i*3+2]);
+	switch(domaintype){
+		case Domain2DhorizontalEnum:
+			element->GetInputListOnVertices(thickness,ThicknessEnum);
+			for(i=0;i<numvertices;i++) pressure[i]=rho_ice*g*thickness[i];
+			dim=2;
+			break;
+		case Domain3DEnum:
+			element->GetVerticesCoordinates(&xyz_list);
+			element->GetInputListOnVertices(surface,SurfaceEnum);
+			for(i=0;i<numvertices;i++) pressure[i]=rho_ice*g*(surface[i]-xyz_list[i*3+2]);
+			dim=2;
+			break;
+		default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
 	}
 	element->AddInput(PressureEnum,pressure,P1Enum);
@@ -2965,13 +3189,22 @@
 	/*Fetch number of nodes and dof for this finite element*/
 	int numnodes = basalelement->GetNumberOfNodes();
-	int numdof   = numnodes*2;
+	int numdof   = numnodes*dim*2; //2xdim DOFs per node
 
 	/*Fetch dof list and allocate solution vectors*/
-	basalelement->GetDofListLocal(&doflist,NoneApproximationEnum,GsetEnum);
+	basalelement->GetDofListLocal(&doflist,MLHOApproximationEnum,GsetEnum); 
 	IssmDouble* values    = xNew<IssmDouble>(numdof);
+	IssmDouble* vbx       = xNew<IssmDouble>(numnodes);
+	IssmDouble* vby       = xNew<IssmDouble>(numnodes);
+   IssmDouble* vshx      = xNew<IssmDouble>(numnodes); 
+   IssmDouble* vshy      = xNew<IssmDouble>(numnodes);
+	IssmDouble* vsx       = xNew<IssmDouble>(numnodes);
+	IssmDouble* vsy       = xNew<IssmDouble>(numnodes);
 	IssmDouble* vx        = xNew<IssmDouble>(numnodes);
 	IssmDouble* vy        = xNew<IssmDouble>(numnodes);
 	IssmDouble* vz        = xNew<IssmDouble>(numnodes);
 	IssmDouble* vel       = xNew<IssmDouble>(numnodes);
+	IssmDouble* n			 = xNew<IssmDouble>(numnodes);
+	IssmDouble* H			 = xNew<IssmDouble>(numnodes);
+	IssmDouble* s			 = xNew<IssmDouble>(numnodes);
 
 	/*Use the dof list to index into the solution vector: */
@@ -2979,37 +3212,134 @@
 
 	/*Transform solution in Cartesian Space*/
-	basalelement->TransformSolutionCoord(&values[0],XYEnum);
-	basalelement->FindParam(&domaintype,DomainTypeEnum);
-
-	/*Ok, we have vx and vy in values, fill in vx and vy arrays: */
-	for(i=0;i<numnodes;i++){
-		vx[i]=values[i*2+0];
-		vy[i]=values[i*2+1];
-
-		/*Check solution*/
-		if(xIsNan<IssmDouble>(vx[i])) _error_("NaN found in solution vector");
-		if(xIsInf<IssmDouble>(vx[i])) _error_("Inf found in solution vector");
-		if(xIsNan<IssmDouble>(vy[i])) _error_("NaN found in solution vector");
-		if(xIsInf<IssmDouble>(vy[i])) _error_("Inf found in solution vector");
-	}
-
-	/*Get Vz and compute vel*/
-	basalelement->GetInputListOnNodes(&vz[0],VzEnum,0.);
-	for(i=0;i<numnodes;i++) vel[i]=sqrt(vx[i]*vx[i] + vy[i]*vy[i] + vz[i]*vz[i]);
-
-	/*Add vx and vy as inputs to the tria element: */
-	element->AddBasalInput(VxEnum,vx,element->GetElementType());
-	element->AddBasalInput(VyEnum,vy,element->GetElementType());
-	element->AddBasalInput(VelEnum,vel,element->GetElementType());
+	if(dim==2) basalelement->TransformSolutionCoord(&values[0],XYEnum);
+
+   /*Ok, we have vx and vy in values, fill in vx and vy arrays: */
+   for(i=0;i<numnodes;i++){ //numnodes of the 2D mesh in which the MLHO is written
+      vbx[i] =values[i*4+0]; //base vx
+      vshx[i]=values[i*4+1]; //shear vx
+		vsx[i] =vbx[i]+vshx[i]; //surface vx
+		if(xIsNan<IssmDouble>(vbx[i]))	_error_("NaN found in solution vector");
+      if(xIsInf<IssmDouble>(vbx[i]))	_error_("Inf found in solution vector");
+		if(xIsNan<IssmDouble>(vshx[i]))	_error_("NaN found in solution vector");
+      if(xIsInf<IssmDouble>(vshx[i]))	_error_("Inf found in solution vector");
+		vby[i] =values[i*4+2]; //base vy
+		vshy[i]=values[i*4+3]; //shear vy
+		vsy[i] =vby[i]+vshy[i]; //surface vy
+		if(xIsNan<IssmDouble>(vby[i]))	_error_("NaN found in solution vector");
+		if(xIsInf<IssmDouble>(vby[i]))	_error_("Inf found in solution vector");
+		if(xIsNan<IssmDouble>(vshy[i]))	_error_("NaN found in solution vector");
+		if(xIsInf<IssmDouble>(vshy[i]))	_error_("Inf found in solution vector");
+	}
+
+	/*Add vx and vy as inputs to the tria element (shear velocities): */
+	element->AddBasalInput(VxShearEnum,vshx,element->GetElementType());
+	element->AddBasalInput(VyShearEnum,vshy,element->GetElementType());
+
+	/*Add vx and vy as inputs to the tria element (base velocities): */
+	element->AddBasalInput(VxBaseEnum,vbx,element->GetElementType());
+	element->AddBasalInput(VyBaseEnum,vby,element->GetElementType());
+
+	/*Add vx and vy as inputs to the tria element (surface velocities): */
+	element->AddBasalInput(VxSurfaceEnum,vsx,element->GetElementType());
+	element->AddBasalInput(VySurfaceEnum,vsy,element->GetElementType());
+
+	/*Compute the vertically averaged velocities on each node*/
+	basalelement->GetInputListOnNodes(&n[0],MaterialsRheologyNEnum,0.); 
+
+	/* Reconstruct vx, vy and vz solutions for 3D problem
+	 * Add vx and vy as inputs to the tria element (vertically averaged velocities): */
+
+   switch(domaintype){
+      case Domain2DhorizontalEnum:
+			for(i=0;i<numnodes;i++){ //numnodes of the 2D mesh in which the MLHO is written
+				vx[i]=vbx[i]+vshx[i]*(n[i]+1)/(n[i]+2);
+				vy[i]=vby[i]+vshy[i]*(n[i]+1)/(n[i]+2);
+				vel[i]=sqrt(vx[i]*vx[i] + vy[i]*vy[i]); 
+			}
+			element->AddBasalInput(VxEnum,vx,element->GetElementType());
+			element->AddBasalInput(VyEnum,vy,element->GetElementType());
+			element->AddBasalInput(VelEnum,vel,element->GetElementType()); 
+         break;
+      case Domain3DEnum:
+		   basalelement->GetInputListOnNodes(&H[0],ThicknessEnum,0.);
+		   basalelement->GetInputListOnNodes(&s[0],SurfaceEnum,0.);
+			element->Recover3DMLHOInput(VxEnum, numnodes, vbx, vshx, n, H, s);
+			element->Recover3DMLHOInput(VyEnum, numnodes, vby, vshy, n, H, s);
+			break;
+		default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
+	}
 
 	/*Free ressources:*/
 	xDelete<IssmDouble>(vel);
+	xDelete<IssmDouble>(vx);
+	xDelete<IssmDouble>(vy);
 	xDelete<IssmDouble>(vz);
-	xDelete<IssmDouble>(vy);
-	xDelete<IssmDouble>(vx);
+	xDelete<IssmDouble>(vby);
+	xDelete<IssmDouble>(vbx);
+	xDelete<IssmDouble>(vsy);
+	xDelete<IssmDouble>(vsx);
+	xDelete<IssmDouble>(vshy);
+	xDelete<IssmDouble>(vshx);
 	xDelete<IssmDouble>(values);
 	xDelete<IssmDouble>(xyz_list);
+	xDelete<IssmDouble>(n);
+	xDelete<IssmDouble>(s);
+	xDelete<IssmDouble>(H);
 	xDelete<int>(doflist);
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
+}/*}}}*/
+void           StressbalanceAnalysis::GetSolutionFromInputsMLHO(Vector<IssmDouble>* solution,Element* element){/*{{{*/
+
+	IssmDouble   vbx,vby,vshx,vshy;
+	int          domaintype,dim,approximation,dofpernode;
+	int*         doflist = NULL;
+
+	/*Get some parameters*/
+	element->FindParam(&domaintype,DomainTypeEnum);
+	switch(domaintype){
+		case Domain2DhorizontalEnum: dim = 2; dofpernode = 4; break;
+		case Domain3DEnum: dim = 2; dofpernode = 4; break;
+		case Domain2DverticalEnum: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet"); break;
+		default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
+	}
+
+	/*Fetch number of nodes and dof for this finite element*/
+	int numnodes = element->GetNumberOfNodes();
+	int numdof   = numnodes*dofpernode;
+	element->GetInputValue(&approximation,ApproximationEnum);
+	if(approximation!=MLHOApproximationEnum) _error_("mesh "<<EnumToStringx(approximation)<<" not supported here");
+
+	/*Fetch dof list and allocate solution vector*/
+	element->GetDofList(&doflist,approximation,GsetEnum); 
+	IssmDouble* values = xNew<IssmDouble>(numdof);
+
+	/*Get inputs*/
+	Input* vxbase_input	=element->GetInput(VxBaseEnum);	_assert_(vxbase_input);
+	Input* vxshear_input	=element->GetInput(VxShearEnum);	_assert_(vxshear_input);
+	Input* vybase_input	=element->GetInput(VyBaseEnum);	_assert_(vybase_input);
+	Input* vyshear_input	=element->GetInput(VyShearEnum);	_assert_(vyshear_input);
+
+	/*Ok, we have vx and vy in values, fill in vx and vy arrays: */
+	Gauss* gauss=element->NewGauss();
+	for(int i=0;i<numnodes;i++){
+		gauss->GaussNode(element->FiniteElement(),i);
+
+		/*Recover vx and vy*/
+		vxbase_input->GetInputValue(&vbx,gauss);	//base vx
+		vxshear_input->GetInputValue(&vshx,gauss);//shear vx
+		values[i*dofpernode+0]=vbx;  //base vx
+		values[i*dofpernode+1]=vshx; //shear vx
+		vybase_input->GetInputValue(&vby,gauss);	//base vy
+		vyshear_input->GetInputValue(&vshy,gauss);//shear vy
+		values[i*dofpernode+2]=vby; //base vy
+		values[i*dofpernode+3]=vshy;//shear vy  
+	}
+
+	solution->SetValues(numdof,doflist,values,INS_VAL);
+
+	/*Free ressources:*/
+	delete gauss;
+	xDelete<IssmDouble>(values);
+	xDelete<int>(doflist);
 }/*}}}*/
 
@@ -3095,5 +3425,5 @@
 	if(!element->IsIceInElement()) return NULL;
 
-	if(element->IsFloating() || !element->IsOnBase()) return NULL;
+	if(element->IsAllFloating() || !element->IsOnBase()) return NULL;
 
 	/*Intermediaries*/
@@ -3123,5 +3453,6 @@
 
 	/*build friction object, used later on: */
-	Friction* friction=new Friction(element,dim==3?2:1);
+	/*dim=4 is special for HO, which is actually 2.5D*/
+	Friction* friction=new Friction(element,dim==3?2.5:1);
 
 	/*Recover portion of element that is grounded*/
@@ -3816,5 +4147,5 @@
 ElementMatrix* StressbalanceAnalysis::CreateKMatrixFSShelf(Element* element){/*{{{*/
 
-	if(!element->IsFloating() || !element->IsOnBase()) return NULL;
+	if(!element->IsAllFloating() || !element->IsOnBase()) return NULL;
 
 	/*If on not water or not FS, skip stiffness: */
@@ -4040,5 +4371,4 @@
 	if(dim==3){vz_input=element->GetInput(VzEnum); _assert_(vz_input);}
 
-
 	/* Start  looping on the number of gaussian points: */
 	Gauss* gauss = element->NewGauss(5);
@@ -4048,5 +4378,4 @@
 		element->NodalFunctionsPressure(pbasis,gauss);
 		element->material->ViscosityFS(&viscosity,dim,xyz_list,gauss,vx_input,vy_input,vz_input);
-
 
 		if(dim==3 || dim==2){
@@ -4139,8 +4468,7 @@
 		mk = 1.0 /3.0;
 		element->ElementSizes(&hx,&hy,&hz);
-		hk = max(max(hx, hy), hz);
-		// if(!element->IsOnDirichletBoundary()) {
-			Tau = - mk * hk * hk * 0.125 / viscosity;
-
+		// hk = max(max(hx, hy), hz);
+		hk = max(hx, hy);
+		Tau = - mk * hk * hk * 0.125 / viscosity;
 
 		for (int q=0;q<dim;q++){
@@ -4148,5 +4476,5 @@
 			for (int p=0;p<dim;p++){
 				for(int i=0;i<vnumnodes;i++){
-					SU[q*vnumnodes*(dim+1)+i*dim+p] = (-gradViscos[p])*vdbasis[q*vnumnodes+i];
+					SU[q*numdof+i*dim+p] = (-gradViscos[p])*vdbasis[q*vnumnodes+i];
 				}
 			}
@@ -4154,10 +4482,10 @@
 			for(int i=0;i<vnumnodes;i++){
 				for (int p=0;p<dim;p++){
-					SU[q*vnumnodes*(dim+1)+i*dim+q] += (-gradViscos[p])*vdbasis[p*vnumnodes+i];
+					SU[q*numdof+i*dim+q] += (-gradViscos[p])*vdbasis[p*vnumnodes+i];
 				}
 			}
 			/* column 4 for the pressure */
-			for(int i=0;i<vnumnodes;i++){
-					SU[q*vnumnodes*(dim+1)+dim*vnumnodes+i] = FSreconditioning*vdbasis[q*vnumnodes+i];
+			for(int i=0;i<pnumnodes;i++){
+					SU[q*numdof+dim*vnumnodes+i] = FSreconditioning*vdbasis[q*vnumnodes+i];
 			}
 		}
@@ -4225,4 +4553,5 @@
 	int vnumnodes = element->NumberofNodesVelocity();
 	int pnumnodes = element->NumberofNodesPressure();
+	int numdof    = vnumnodes*dim + pnumnodes;
 
 	/*Prepare coordinate system list*/
@@ -4290,11 +4619,7 @@
 		mk = 1.0 /3.0;
 		element->ElementSizes(&hx,&hy,&hz);
-		hk = max(max(hx, hy), hz);
-		// if(!element->IsOnDirichletBoundary()) {
-			Tau = - mk * hk * hk * 0.125 / viscosity;
-		// }
-		// else {
-		// 	Tau = 0.0;
-		// }
+		// hk = max(max(hx, hy), hz);
+		hk = max(hx, hy);
+		Tau = - mk * hk * hk * 0.125 / viscosity;
 
 		for (int q=0;q<dim;q++){
@@ -4302,5 +4627,5 @@
 			for (int p=0;p<dim;p++){
 				for(int i=0;i<vnumnodes;i++){
-					SU[q*vnumnodes*(dim+1)+i*dim+p] = (-gradViscos[p])*vdbasis[q*vnumnodes+i];
+					SU[q*numdof+i*dim+p] = (-gradViscos[p])*vdbasis[q*vnumnodes+i];
 				}
 			}
@@ -4308,13 +4633,12 @@
 			for(int i=0;i<vnumnodes;i++){
 				for (int p=0;p<dim;p++){
-					SU[q*vnumnodes*(dim+1)+i*dim+q] += (-gradViscos[p])*vdbasis[p*vnumnodes+i];
+					SU[q*numdof+i*dim+q] += (-gradViscos[p])*vdbasis[p*vnumnodes+i];
 				}
 			}
 			/* column 4 for the pressure */
-			for(int i=0;i<vnumnodes;i++){
-					SU[q*vnumnodes*(dim+1)+dim*vnumnodes+i] = FSreconditioning*vdbasis[q*vnumnodes+i];
+			for(int i=0;i<pnumnodes;i++){
+					SU[q*numdof+dim*vnumnodes+i] = FSreconditioning*vdbasis[q*vnumnodes+i];
 			}
 		}
-
 		for(i=0;i<vnumnodes;i++){
 			pe->values[i*dim+0] += +rho_ice*forcex *Jdet*gauss->weight*vbasis[i];
@@ -4325,6 +4649,6 @@
 		}
 
-		for(int i=0;i<vnumnodes*(dim+1);i++){
-			pe->values[i] += Tau*Jdet*gauss->weight*rho_ice*(-gravity)*SU[(dim-1)*(dim+1)*vnumnodes+i];
+		for(int i=0;i<numdof;i++){
+			pe->values[i] += Tau*Jdet*gauss->weight*rho_ice*(-gravity)*SU[(dim-1)*numdof+i];
 		}
 	}
@@ -4541,5 +4865,5 @@
 ElementMatrix* StressbalanceAnalysis::CreateKMatrixFSFriction(Element* element){/*{{{*/
 
-	if(element->IsFloating() || !element->IsOnBase()) return NULL;
+	if(element->IsAllFloating() || !element->IsOnBase()) return NULL;
 
 	/*If on water or not FS, skip stiffness: */
@@ -4813,5 +5137,5 @@
 ElementMatrix* StressbalanceAnalysis::CreateKMatrixFSFriction(Element* element){/*{{{*/
 
-	if(element->IsFloating() || !element->IsOnBase()) return NULL;
+	if(element->IsAllFloating() || !element->IsOnBase()) return NULL;
 
 	/*If on water or not FS, skip stiffness: */
@@ -5033,5 +5357,5 @@
 ElementMatrix* StressbalanceAnalysis::CreateKMatrixFSFrictionNitsche(Element* element){/*{{{*/
 
-	if(element->IsFloating() || !element->IsOnBase()) return NULL;
+	if(element->IsAllFloating() || !element->IsOnBase()) return NULL;
 
 	/*If on water or not FS, skip stiffness: */
@@ -5052,5 +5376,4 @@
 	/*coefficient of Nitsche's method*/
 	IssmDouble gamma, hx, hy, hz;
-	IssmDouble pnu, qnv;
 
 	/*Get problem dimension*/
@@ -5069,7 +5392,4 @@
 	IssmDouble* vdbasis = xNew<IssmDouble>(dim*vnumnodes);
 	IssmDouble* pbasis  = xNew<IssmDouble>(pnumnodes);
-	IssmDouble* vdbasisn = xNew<IssmDouble>(vnumnodes);
-	IssmDouble* nsigma = xNew<IssmDouble>(numdof);
-	IssmDouble  bed_normal[3], bed_tangent[6];
 
 	/*Prepare coordinate system list*/
@@ -5104,6 +5424,4 @@
 	}
 
-	element->NormalBase(&bed_normal[0],xyz_list_base);
-	element->TangentBase(&bed_tangent[0], &bed_normal[0]);
 	element->ElementSizes(&hx,&hy,&hz);
 	element->FindParam(&gamma,FeFSNitscheGammaEnum);
@@ -5131,24 +5449,12 @@
 		element->material->ViscosityFS(&viscosity,dim,xyz_list,gauss,vx_input,vy_input,vz_input);
 
-		/*Frictions*/
 		for(int i=0;i<vnumnodes;i++){
 			for(int j=0;j<vnumnodes;j++){
-				for (int d=0; d<2; d++) {
-					for (int p=0; p<dim; p++) {
-						for (int q=0; q<dim; q++) {
-							Ke->values[(dim*i+p)*numdof+dim*j+q] += alpha2*gauss->weight*Jdet*vbasis[i]*vbasis[j]*bed_tangent[d*3+p]*bed_tangent[d*3+q];
-						}
-					}
+				for (int d=0; d<dim; d++) {
+						Ke->values[(dim*i+d)*numdof+dim*j+d] += alpha2*gauss->weight*Jdet*vbasis[i]*vbasis[j];
 				}
 			}
 		}
 		/* -------- Nitsche terms -------- */
-		/* n\cdot\nabla\phi*/
-		for(int i=0;i<vnumnodes;i++){
-			vdbasisn[i] = 0.0;
-			for (int d=0; d<dim; d++) {
-				vdbasisn[i] += bed_normal[d]*vdbasis[d*vnumnodes+i];
-			}
-		}
 		/* Boundary terms for integration by parts.
 			The coefficient matrix of n*sigma*n-gamma*n*u is stored in the following order:
@@ -5157,50 +5463,26 @@
 		*/
 		for(int i=0;i<vnumnodes;i++){
-			for(int d=0;d<dim;d++){
-				nsigma[d*vnumnodes+i] = 2.0 * viscosity * bed_normal[d]*vdbasisn[i];
+			for(int j=0;j<vnumnodes;j++){
+				/* gamma*(n*u)*(n*v) */
+				Ke->values[(dim*i+(dim-1))*numdof+dim*j+(dim-1)] += gauss->weight*Jdet * (gamma*viscosity) * vbasis[j] * vbasis[i];
+				/* -sigma(v)*(n*u) */
+				Ke->values[(dim*i+(dim-1))*numdof+dim*j+(dim-1)] += (- gauss->weight*Jdet) * 2.0 * viscosity * (-vbasis[j]) * vdbasis[(dim-1)*vnumnodes+i];
+				/* -sigma(u)*(n*v) */
+				Ke->values[(dim*i+(dim-1))*numdof+dim*j+(dim-1)] += (- gauss->weight*Jdet) * 2.0 * viscosity * vdbasis[(dim-1)*vnumnodes+j] * (-vbasis[i]);
 			}
 		}
-		for(int i=0;i<pnumnodes;i++){
-			nsigma[dim*vnumnodes+i] = -FSreconditioning*pbasis[i];
-		}
-
-		/*velocity components A11 */
-		for(int i=0;i<vnumnodes;i++){
-			for (int p=0; p<dim; p++) {
-				for(int j=0;j<vnumnodes;j++){
-					for (int q=0; q<dim; q++) {
-						/* gamma*(n*u)*(n*v) */
-						Ke->values[(dim*i+p)*numdof+dim*j+q] += gauss->weight*Jdet * (-gamma) * bed_normal[q] * vbasis[j]*bed_normal[p] * vbasis[i];
-						/* sigma(u)*(n*v) */
-						Ke->values[(dim*i+p)*numdof+dim*j+q] += (- gauss->weight*Jdet)* nsigma[p*vnumnodes+i] * bed_normal[q] * vbasis[j];
-						/* sigma(v)*(n*u) */
-						Ke->values[(dim*i+p)*numdof+dim*j+q] += (- gauss->weight*Jdet)* bed_normal[p] * vbasis[i] * nsigma[q*vnumnodes+j];
-					}
-				}
+		/* pressure x velocity  component A12, +p*(n*v) */
+		for(int k=0;k<pnumnodes;k++){
+			for(int i=0;i<vnumnodes;i++){
+				Ke->values[(dim*i+dim-1)*numdof+dim*vnumnodes+k] += gauss->weight*Jdet * FSreconditioning*pbasis[k] * (-vbasis[i]);
 			}
 		}
-
-		/* pressure x velocity  component A12 */
+		/* velocity x pressure component A21, +(n*u)*q */
 		for(int k=0;k<pnumnodes;k++){
-			pnu = nsigma[dim*vnumnodes+k];
-			for(int i=0;i<vnumnodes;i++){
-				for (int p=0;p<dim;p++) {
-					Ke->values[(dim*i+p)*numdof+dim*vnumnodes+k] += gauss->weight*Jdet * pnu * (- bed_normal[p] * vbasis[i]);
-				}
+			for(int j=0;j<vnumnodes;j++){
+				Ke->values[(dim*vnumnodes+k)*numdof+dim*j+dim-1] += gauss->weight*Jdet * (-vbasis[j]) * FSreconditioning*pbasis[k];
 			}
 		}
-		/* velocity x pressure component A21 */
-		for(int k=0;k<pnumnodes;k++){
-			qnv = nsigma[dim*vnumnodes+k];
-			for(int j=0;j<vnumnodes;j++){
-				for (int q=0;q<dim;q++) {
-					Ke->values[(dim*vnumnodes+k)*numdof+dim*j+q] += gauss->weight*Jdet * ( - bed_normal[q] * vbasis[j]) * qnv;
-				}
-			}
-		}
-	}
-
-	/*Transform Coordinate System*/
-	element->TransformStiffnessMatrixCoord(Ke,cs_list);
+	}
 
 	/*Clean up and return*/
@@ -5212,7 +5494,4 @@
 	xDelete<IssmDouble>(vdbasis);
 	xDelete<IssmDouble>(pbasis);
-	xDelete<IssmDouble>(vdbasisn);
-	xDelete<IssmDouble>(nsigma);
-	xDelete<int>(cs_list);
 	return Ke;
 }/*}}}*/
@@ -5300,5 +5579,5 @@
 
 	/*Get basal element*/
-	if(!element->IsOnBase() || !element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || !element->IsAllFloating()) return NULL;
 
 	/*Get problem dimension*/
@@ -6854,5 +7133,5 @@
 	/*If on water or not FS, skip stiffness: */
 	element->GetInputValue(&approximation,ApproximationEnum);
-	if(element->IsFloating() || !element->IsOnBase()) return NULL;
+	if(element->IsAllFloating() || !element->IsOnBase()) return NULL;
 
 	int vnumnodes = element->NumberofNodesVelocity();
@@ -7071,5 +7350,5 @@
 	if(!element->IsIceInElement()) return NULL;
 
-	if(element->IsFloating() || !element->IsOnBase()) return NULL;
+	if(element->IsAllFloating() || !element->IsOnBase()) return NULL;
 
 	/*Constants*/
@@ -7299,5 +7578,5 @@
 
 	/*Initialize Element matrix and return if necessary*/
-	if(element->IsFloating() || !element->IsOnBase()) return NULL;
+	if(element->IsAllFloating() || !element->IsOnBase()) return NULL;
 
 	/*Build a tria element using the 3 nodes of the base of the penta. Then use
@@ -7306,5 +7585,5 @@
 	Element* basalelement = element->SpawnBasalElement();
 	ElementMatrix* Ke=CreateKMatrixSSAFriction(basalelement);
-	basalelement->DeleteMaterials(); delete basalelement;
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 
 	/*clean-up and return*/
@@ -7416,5 +7695,5 @@
 
 	/*Initialize Element vector and return if necessary*/
-	if(!element->IsOnBase() || element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || element->IsAllFloating()) return NULL;
 	element->GetInputValue(&approximation,ApproximationEnum);
 	if(approximation!=HOFSApproximationEnum) return NULL;
@@ -7582,5 +7861,5 @@
 
 	/*Initialize Element vector and return if necessary*/
-	if(!element->IsOnBase() || element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || element->IsAllFloating()) return NULL;
 	element->GetInputValue(&approximation,ApproximationEnum);
 	if(approximation!=SSAFSApproximationEnum) return NULL;
Index: issm/trunk/src/c/analyses/StressbalanceAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/StressbalanceAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
@@ -64,4 +65,5 @@
 		ElementVector* CreatePVectorMLHODrivingStress(Element* element);
 		void           InputUpdateFromSolutionMLHO(IssmDouble* solution,Element* element);
+		void           GetSolutionFromInputsMLHO(Vector<IssmDouble>* solution,Element* element);
 		/*HO*/
 		ElementMatrix* CreateJacobianMatrixHO(Element* element);
Index: issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.cpp	(revision 26744)
@@ -181,4 +181,7 @@
 		femmodel->SetCurrentConfiguration(StressbalanceSIAAnalysisEnum);
 		solutionsequence_linear(femmodel);
+}/*}}}*/
+void           StressbalanceSIAAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+_error_("not implemented");
 }/*}}}*/
 ElementVector* StressbalanceSIAAnalysis::CreateDVector(Element* element){/*{{{*/
Index: issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 26744)
@@ -5,4 +5,6 @@
 #include "../modules/modules.h"
 #include "../solutionsequences/solutionsequences.h"
+
+//#define INWOOVZ 1 //For Inwoo Park 0: incompressible assumption(IA), 1: internal deformation(ID), 2: IA+ID
 
 /*Model processing*/
@@ -105,5 +107,5 @@
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.surface",SurfaceEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.base",BaseEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.solidearth.initialsealevel",SealevelEnum,0);
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sealevel",SealevelEnum,0);
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
 	if(iomodel->domaintype!=Domain2DhorizontalEnum){
@@ -112,13 +114,20 @@
 	}
 	iomodel->FetchDataToInput(inputs,elements,"md.basalforcings.groundedice_melting_rate",BasalforcingsGroundediceMeltingRateEnum);
-	//iomodel->FetchDataToInput(inputs,elements,"md.smb.mass_balance",SmbMassBalanceEnum);
-
+	#ifdef INWOOVZ
+	iomodel->FetchDataToInput(inputs,elements,"md.smb.mass_balance",SmbMassBalanceEnum);
+	#endif
 
 	/*Add basal forcings to compute melt rate*/
+	bool isstochastic;
 	int basalforcing_model;
 	iomodel->FindConstant(&basalforcing_model,"md.basalforcings.model");
+	iomodel->FindConstant(&isstochastic,"md.stochasticforcing.isstochasticforcing");
 	switch(basalforcing_model){
 		case FloatingMeltRateEnum:
 			iomodel->FetchDataToInput(inputs,elements,"md.basalforcings.floatingice_melting_rate",BasalforcingsFloatingiceMeltingRateEnum);
+			if(isstochastic){
+            iomodel->FetchDataToInput(inputs,elements,"md.stochasticforcing.default_id",StochasticForcingDefaultIdEnum);
+            iomodel->FetchDataToInput(inputs,elements,"md.basalforcings.floatingice_melting_rate",BaselineBasalforcingsFloatingiceMeltingRateEnum);
+         }
 			break;
 		case LinearFloatingMeltRateEnum:
@@ -153,5 +162,5 @@
 void StressbalanceVerticalAnalysis::UpdateParameters(Parameters* parameters,IoModel* iomodel,int solution_enum,int analysis_enum){/*{{{*/
 
-	/*No specific parameters*/
+	/* specific parameters*/
 
 }/*}}}*/
@@ -163,4 +172,7 @@
 		femmodel->SetCurrentConfiguration(StressbalanceVerticalAnalysisEnum);
 		solutionsequence_linear(femmodel);
+}/*}}}*/
+void           StressbalanceVerticalAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
 }/*}}}*/
 ElementVector* StressbalanceVerticalAnalysis::CreateDVector(Element* element){/*{{{*/
@@ -576,4 +588,45 @@
 	}
 
+	#ifdef INWOOVZ
+	IssmDouble*  thickness = xNew<IssmDouble>(numnodes);
+	IssmDouble*  base	     = xNew<IssmDouble>(numnodes);
+	IssmDouble*  smb       = xNew<IssmDouble>(numnodes);
+
+	IssmDouble rheology_n=element->material->GetN();
+	IssmDouble isvelbc   = 10./(365.25*24*3600); /*10 m/yr*/
+	/*Set analytical vertical velocity field at slow flow region.*/
+	if(INWOOVZ == 1){
+		element->GetInputListOnNodes(&thickness[0],ThicknessEnum,0.);
+		element->GetInputListOnNodes(&base[0],BaseEnum,0.);
+		element->GetInputListOnNodes(&smb[0],SmbMassBalanceEnum,0.);
+		for(i=0;i<numnodes;i++){
+			IssmDouble eta = (base[i]+thickness[i]-xyz_list[i*3+2])/thickness[i];
+			vz[i] = -(pow(eta,rheology_n+2.0)-1-(rheology_n+2.0)*(eta-1.))/(rheology_n+1.)*smb[i];
+		}	
+	}
+	else if(INWOOVZ== 2) {
+		element->GetInputListOnNodes(&thickness[0],ThicknessEnum,0.);
+		element->GetInputListOnNodes(&base[0],BaseEnum,0.);
+		element->GetInputListOnNodes(&smb[0],SmbMassBalanceEnum,0.);
+		for(i=0;i<numnodes;i++){
+			if ( vx[i]*vx[i]+vy[i]*vy[i] < isvelbc*isvelbc ){
+				IssmDouble eta = (base[i]+thickness[i]-xyz_list[i*3+2])/thickness[i];
+				vz[i] = -(pow(eta,rheology_n+2.0)-1-(rheology_n+2.0)*(eta-1.))/(rheology_n+1.)*smb[i];
+			}
+		}	
+	}
+	else if(INWOOVZ==0){
+		/*nothing to add*/
+	}
+	else{
+		_error_("not supported yet");
+	}
+
+	/*Cleanup*/
+	xDelete<IssmDouble>(smb);
+	xDelete<IssmDouble>(base);
+	xDelete<IssmDouble>(thickness);
+	#endif
+
 	/*Now Compute vel*/
 	for(i=0;i<numnodes;i++) vel[i]=pow( pow(vx[i],2.0) + pow(vy[i],2.0) + pow(vz[i],2.0) , 0.5);
Index: issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/ThermalAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/ThermalAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/ThermalAnalysis.cpp	(revision 26744)
@@ -133,5 +133,5 @@
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.surface",SurfaceEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.base",BaseEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.solidearth.initialsealevel",SealevelEnum,0);
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sealevel",SealevelEnum,0);
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ocean_levelset",MaskOceanLevelsetEnum);
@@ -299,4 +299,7 @@
 	_error_("not implemented");
 }/*}}}*/
+void           ThermalAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* ThermalAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
@@ -327,5 +330,5 @@
 
 	/*Initialize Element matrix and return if necessary*/
-	if(!element->IsOnBase() || !element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || !element->IsAllFloating()) return NULL;
 
 	IssmDouble  dt,Jdet,D;
@@ -333,5 +336,5 @@
 
 	/*Get basal element*/
-	if(!element->IsOnBase() || !element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || !element->IsAllFloating()) return NULL;
 
 	/*Fetch number of nodes for this finite element*/
@@ -534,5 +537,5 @@
 
 	/* Geothermal flux on ice sheet base and basal friction */
-	if(!element->IsOnBase() || element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || element->IsAllFloating()) return NULL;
 
 	IssmDouble  dt,Jdet,geothermalflux,vx,vy,vz;
@@ -598,5 +601,5 @@
 
 	/*Get basal element*/
-	if(!element->IsOnBase() || !element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || !element->IsAllFloating()) return NULL;
 
 	/*Fetch number of nodes for this finite element*/
Index: issm/trunk/src/c/analyses/ThermalAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/ThermalAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/ThermalAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/UzawaPressureAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/UzawaPressureAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/UzawaPressureAnalysis.cpp	(revision 26744)
@@ -61,4 +61,7 @@
 /*Finite Element Analysis*/
 void           UzawaPressureAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           UzawaPressureAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
Index: issm/trunk/src/c/analyses/UzawaPressureAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/UzawaPressureAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/UzawaPressureAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
